<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>Advanced topics :: Wovalab open-source projects</title>
    <link rel="canonical" href="https://wovalab.gitlab.io/open-source/docs/asciidoc-toolkit/latest/advanced-topics.html">
    <link rel="prev" href="api.html">
    <link rel="next" href="known-issues.html">
    <meta name="generator" content="Antora 3.0.2">
    <link rel="stylesheet" href="../../_/css/site.css">
    <script async src="https://www.googletagmanager.com/gtag/js?id=G-3KJN6K6QRD"></script>
    <script>function gtag(){dataLayer.push(arguments)};window.dataLayer=window.dataLayer||[];gtag('js',new Date());gtag('config','G-3KJN6K6QRD')</script>
    <script>var uiRootPath = '../../_'</script>
    <link rel="icon" href="../../favicon.ico" type="image/x-icon">  </head>
  <body class="article">
<header class="header">
  <nav class="navbar">
    <div class="navbar-brand">
      <a class="navbar-item logo" title="Wovalab" href="https://www.wovalab.com"><img src="../../_/img/wovalab-light-vertical.svg" alt="Wovalab" width="64"></a>
      <a class="navbar-item" href="https://wovalab.gitlab.io/open-source/docs">Wovalab open-source projects</a>
      <div class="navbar-item search hide-for-print">
        <div id="search-field" class="field">
          <input id="search-input" type="text" placeholder="Search the docs">
          <label class="filter checkbox">
            <input type="checkbox" data-facet-filter="component:asciidoc-toolkit" checked> In this project
          </label>
        </div>
      </div>
      <button class="navbar-burger" data-target="topbar-nav">
        <span></span>
        <span></span>
        <span></span>
      </button>
    </div>
  </nav>
</header>
<div class="body">
<div class="nav-container" data-component="asciidoc-toolkit" data-version="1.8">
  <aside class="nav">
    <div class="panels">
<div class="nav-panel-menu is-active" data-panel="menu">
  <nav class="nav-menu">
    <h3 class="title"><a href="index.html">AsciiDoc toolkit</a></h3>
<ul class="nav-list">
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="index.html">What&#8217;s new</a>
  </li>
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="general-info.html">General information</a>
  </li>
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="api.html">API description</a>
  </li>
  <li class="nav-item is-current-page" data-depth="1">
    <a class="nav-link" href="advanced-topics.html">Advanced topics</a>
  </li>
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="known-issues.html">Known issues</a>
  </li>
</ul>
  </li>
</ul>
  </nav>
</div>
<div class="nav-panel-explore" data-panel="explore">
  <div class="context">
    <span class="title">AsciiDoc toolkit</span>
    <span class="version">1.8</span>
  </div>
  <ul class="components">
    <li class="component is-current">
      <a class="title" href="index.html">AsciiDoc toolkit</a>
      <ul class="versions">
        <li class="version is-current is-latest">
          <a href="index.html">1.8</a>
        </li>
        <li class="version">
          <a href="../1.7/index.html">1.7</a>
        </li>
        <li class="version">
          <a href="../1.6/index.html">1.6</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../antidoc/latest/index.html">Antidoc</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../antidoc/latest/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../antidoc-addon-lvproj/latest/index.html">Antidoc add-on: LabVIEW project</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../antidoc-addon-lvproj/latest/index.html">2.1</a>
        </li>
        <li class="version">
          <a href="../../antidoc-addon-lvproj/2.0/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../antidoc-addon-toolkit/latest/index.html">Antidoc add-on: LabVIEW toolkit</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../antidoc-addon-toolkit/latest/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../cli-tool-for-antidoc/latest/index.html">Antidoc CLI</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../cli-tool-for-antidoc/latest/index.html">2.1</a>
        </li>
        <li class="version">
          <a href="../../cli-tool-for-antidoc/2.0/index.html">2.0</a>
        </li>
        <li class="version">
          <a href="../../cli-tool-for-antidoc/1.2.1/index.html">1.2.1</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../about/index.html">Community</a>
    </li>
  </ul>
</div>    </div>
  </aside>
</div>
<main class="article">
<div class="toolbar" role="navigation">
<button class="nav-toggle"></button>
  <a href="../../index.html" class="home-link"></a>
<nav class="breadcrumbs" aria-label="breadcrumbs">
  <ul>
    <li><a href="index.html">AsciiDoc toolkit</a></li>
    <li><a href="advanced-topics.html">Advanced topics</a></li>
  </ul>
</nav>
<div class="page-versions">
  <button class="version-menu-toggle" title="Show other versions of page">1.8</button>
  <div class="version-menu">
    <a class="version is-current" href="advanced-topics.html">1.8</a>
    <a class="version is-missing" href="../1.7/index.html">1.7</a>
    <a class="version is-missing" href="../1.6/index.html">1.6</a>
  </div>
</div>
  <div class="edit-this-page"><a href="https://gitlab.com/wovalab/open-source/asciidoc-toolkit/edit/docs/v1.8/docs/modules/ROOT/pages/advanced-topics.adoc">Edit this Page</a></div>
  </div>
  <div class="content">
<aside class="toc sidebar" data-title="Contents" data-levels="2">
  <div class="toc-menu"></div>
</aside>
<article class="doc">
<h1 class="page">Advanced topics</h1>
<div class="sect1">
<h2 id="add-attributes-to-blocs"><a class="anchor" href="#add-attributes-to-blocs"></a>Add attributes to blocs</h2>
<div class="sectionbody">
<div class="quoteblock">
<blockquote>
<div class="paragraph">
<p>Element attributes are a powerful means of controlling the built-in settings of individual block and inline elements in the AsciiDoc syntax.</p>
</div>
</blockquote>
<div class="attribution">
&#8212; Asciidoctor documentation website
</div>
</div>
<div class="paragraph">
<p>Some attributes can be set to blocs directly from the <code>Create</code> functions.
For example, you can set the alignment of a paragraph during its creation.
But if some predefined attributes exist, the user-defined attributes cannot be known by the toolkit.</p>
</div>
<div class="paragraph">
<p>To set attributes to any of the blocs that can support them use the property node below.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/set-attributes.png" alt="set attributes">
</div>
<div class="title">Figure 1. Center a table using a bloc attribute</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="render-adoc-file-using-a-custom-installation-of-the-asciidoctor-toolchain"><a class="anchor" href="#render-adoc-file-using-a-custom-installation-of-the-asciidoctor-toolchain"></a>Render adoc file using a custom installation of the Asciidoctor toolchain</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="rendering-toolchain-general-information"><a class="anchor" href="#rendering-toolchain-general-information"></a>Rendering toolchain general information</h3>
<div class="paragraph">
<p>To generate a PDF/HTML file from adoc files, Asciidoctor is needed, which is written in Ruby.</p>
</div>
<div class="paragraph">
<p>If your adoc file contains diagrams, you need a way to transform the diagram text syntax into an image.
Currently, Asciidoctor supports two extensions:</p>
</div>
<div class="ulist">
<ul>
<li>
<p><a href="https://docs.asciidoctor.org/diagram-extension/latest/">asciidoctor-diagram</a></p>
</li>
<li>
<p><a href="https://github.com/ggrossetie/asciidoctor-kroki">asciidoctor-kroki</a></p>
</li>
</ul>
</div>
<div class="sect3">
<h4 id="asciidoctor-diagram"><a class="anchor" href="#asciidoctor-diagram"></a>asciidoctor-diagram</h4>
<div class="paragraph">
<p>asciidoctor-diagram is the default way to transform text descriptions into an image.
The issue is that this extension needs the rendering tools associated with the diagram syntax you use in your adoc.
Handling all the syntaxes can be tricky.</p>
</div>
<div class="paragraph">
<p>One rendering tool is <a href="https://graphviz.org/">graphviz</a>, which depends on Java.</p>
</div>
</div>
<div class="sect3">
<h4 id="asciidoctor-kroki"><a class="anchor" href="#asciidoctor-kroki"></a>asciidoctor-kroki</h4>
<div class="paragraph">
<p>Kroki provides an HTTP API to convert plain text diagrams to images and supports lots of <a href="https://docs.kroki.io/kroki/diagram-types/">diagrams</a>. By default, the public kroki server is used, so be aware, that online access is needed and that you might be sharing confidential information. To overcome these disadvantages, you can use a local Kroki server.</p>
</div>
<div class="admonitionblock important">
<table>
<tr>
<td class="icon">
<i class="fa icon-important" title="Important"></i>
</td>
<td class="content">
<div class="paragraph">
<p>To provide the rendering feature as an "out-of-the-box" experience, AsciiDoc toolkit for LabVIEW&#8482; installs a custom ruby runtime and the Ruby gems needed to convert adoc files to PDF or HTML files.</p>
</div>
<div class="paragraph">
<p>Images are generated through the public Kroki.io server.</p>
</div>
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>The code below will use the Asciidoctor toolchain installed by the toolkit.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/default-rendering-code.png" alt="default rendering code">
</div>
<div class="title">Figure 2. Default rendering code</div>
</div>
<div class="paragraph">
<p>There are plenty of reasons to use another Asciidoctor toolchain to render your adoc files.
We try to provide a way to help you use those custom installations.</p>
</div>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<i class="fa icon-note" title="Note"></i>
</td>
<td class="content">
to install the Asciidoctor toolchain locally, you can refer see <a href="https://gitlab.com/wovalab/open-source/labview-doc-generator/-/blob/master/Resources/Docs/Install-Asciidoc-Toolchain-long-way.adoc">this document</a>
</td>
</tr>
</table>
</div>
<div class="paragraph">
<p>In the following sections, we list the main use cases you may come across to make you use a different toolchain.</p>
</div>
</div>
</div>
<div class="sect2">
<h3 id="use-a-local-kroki-server"><a class="anchor" href="#use-a-local-kroki-server"></a>Use a local Kroki server</h3>
<div class="paragraph">
<p>For security reasons or performance issues, you may want to use a <a href="https://docs.kroki.io/kroki/setup/install">self-managed Kroki server instance</a> to generate the picture of the diagrams contained in the adoc files.</p>
</div>
<div class="paragraph">
<p>To use this instance, specify its URL in the Init function.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/local-kroki-instance.png" alt="local kroki instance">
</div>
<div class="title">Figure 3. Custom Kroki server</div>
</div>
</div>
<div class="sect2">
<h3 id="use-ascidoctor-diagram-instead-of-kroki"><a class="anchor" href="#use-ascidoctor-diagram-instead-of-kroki"></a>Use ascidoctor-diagram instead of Kroki</h3>
<div class="paragraph">
<p>You don&#8217;t want to use Kroki to generate the picture of the diagrams contained in the adoc files.
In this case, you need to specify the method in the Init function.
You may also probably need to specify the path of the Asciidoctor instance you use.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/asciidoctor-diagram-method.png" alt="asciidoctor diagram method">
</div>
<div class="title">Figure 4. Asciidoctor-diagram method</div>
</div>
<div class="admonitionblock important">
<table>
<tr>
<td class="icon">
<i class="fa icon-important" title="Important"></i>
</td>
<td class="content">
using the <a href="https://docs.asciidoctor.org/diagram-extension/latest/">Ascidoctor Diagram</a> extensions will invoke the necessary external diagram rendering tools to produce an image file that is inserted into your converted document. This implies you will have to install all the these tools on your own.
</td>
</tr>
</table>
</div>
</div>
<div class="sect2">
<h3 id="render-adoc-files-on-linux-or-mac"><a class="anchor" href="#render-adoc-files-on-linux-or-mac"></a>Render adoc files on Linux or Mac</h3>
<div class="paragraph">
<p>The installation of the Asciidoctor toolchain is not currently supported on Linux and Mac operating systems.
However, if you have installed the toolchain manually, you can get the command line to generate the PDF or HTML file with the <code>Obtain Command Line</code> function.</p>
</div>
<div class="paragraph">
<p>You will need to call this command with the appropriate operating system function.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/obtain-command-line.png" alt="obtain command line">
</div>
<div class="title">Figure 5. Obtain the command line to convert your adoc file</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="set-options-to-the-rendering-command"><a class="anchor" href="#set-options-to-the-rendering-command"></a>Set options to the rendering command</h2>
<div class="sectionbody">
<div class="paragraph">
<p>There are many <a href="https://docs.asciidoctor.org/asciidoctor/latest/cli/man1/asciidoctor/#options">options</a> available to run the Asciidoctor toolchain command line.
They can be useful for debugging and also to set document attributes during the conversion process without modifying the adoc files.
To set those options use the property node below.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/set-rendering-options.png" alt="set rendering options">
</div>
<div class="title">Figure 6. Set options</div>
</div>
</div>
</div>
<nav class="pagination">
  <span class="prev"><a href="api.html">API description</a></span>
  <span class="next"><a href="known-issues.html">Known issues</a></span>
</nav>
</article>
  </div>
</main>
</div>
<footer class="footer">
  <p>Wovalab © 2018-2022</p>
</footer>
<script id="site-script" src="../../_/js/site.js" data-ui-root-path="../../_"></script>
<script async src="../../_/js/vendor/highlight.js"></script>
<script src="../../_/js/vendor/lunr.js"></script>
<script src="../../_/js/search-ui.js" id="search-ui-script" data-site-root-path="../.." data-snippet-length="100" data-stylesheet="../../_/css/search.css"></script>
<script async src="../../search-index.js"></script>
  </body>
</html>
